      subroutine chi2c0eb(n,nf,x,y,ye,a,cov,dcda,c0,c0e) 
c bb may 20 2015.
c Determination of the normalization constant c0 for chi2 fit of data 
c y_i with the fit function c0*f. Then in dcda the derivatives of c0 
c with respect to the fit parameters. So far as in chi2dcda.
c In Addition: Error bar of c0 in c0e.
c Input:  data arrays x(n),y(n),ye(n), parameters a(nf) and
c         their covariance matrix cov(nf,nf).
c Output: dcda, c0, c0e.
      include '../../libs/fortran/implicit.sta'
      include '../../libs/fortran/constants.par'
      parameter(mf=30) ! mf maximum number of parameters.
      dimension x(n),y(n),ye(n),a(nf),cov(nf,nf),dcda(nf)
      dimension drda(mf),dsda(mf),dfda(mf)
      if(nf.gt.mf) stop "chi2dcda: nf.gt.mf."
      ltest=.true.
      ltest=.false.
      if(ltest) stop "chi2dcda: ltest."
      r=zero
      s=zero
      c0v=zero
      do j=1,nf
        drda(j)=zero
        dsda(j)=zero
      enddo
      do i=1,n
        call suby(x(i),a,f,dfda,nf)
        ye2i=one/ye(i)**2 ! Inverse errorbar squared.
        ri=f*ye2i
        r=r+y(i)*ri           ! iterate r.
        s=s+f*ri              ! iterate s.
        c0v=c0v+(ri*ye(i))**2 ! iterate for variance c0v.
        addy=y(i)*ye2i
        addf=two*ri
        do j=1,nf
          drda(j)=drda(j)+addy*dfda(j)
          dsda(j)=dsda(j)+addf*dfda(j)
        enddo
      enddo
      c0=r/s
      do j=1,nf
        dcda(j)=(s*drda(j)-r*dsda(j))/s**2
      enddo
      c0v=c0v/s**2
      do i=1,nf
      do j=1,nf
        c0v=c0v+dcda(i)*cov(i,j)*dcda(j)
      enddo
      enddo
      c0e=sqrt(c0v)
      return
      end
