      subroutine chi2dcda(n,nf,x,y,ye,a,dcda,c0) ! bb may 20 2015.
c Determination of the normalization constant c0 for chi2 fit of data 
c y_i with the fit function c0*f. Then in dcda the derivatives of c0 
c with respect to the fit parameters.
c Input: data arrays x(n),y(n),ye(n), parameters a(nf).
c Output: dcda, c0.
c        variable fit parameters a(nf).
      include '../../libs/fortran/implicit.sta'
      include '../../libs/fortran/constants.par'
      parameter(mf=30) ! mf maximum number of parameters.
      dimension drda(mf),dsda(mf),dfda(mf), a(nf),dcda(nf)
      dimension x(n),y(n),ye(n)
      if(nf.gt.mf) stop "chi2dcda: nf.gt.mf."
      ltest=.true.
      ltest=.false.
      if(ltest) stop "chi2dcda: ltest."
      r=zero
      s=zero
      do j=1,nf
        drda(j)=zero
        dsda(j)=zero
      enddo
      do i=1,n
        call suby(x(i),a,f,dfda,nf)
        ye2i=one/ye(i)**2 ! Inverse errorbar squared.
        ri=f*ye2i
        r=r+y(i)*ri     ! iterate r.
        s=s+f*ri        ! iterate s.
        addy=y(i)*ye2i
        addf=two*ri
        do j=1,nf
          drda(j)=drda(j)+addy*dfda(j)
          dsda(j)=dsda(j)+addf*dfda(j)
        enddo
      enddo
      c0=r/s
      do j=1,nf
        dcda(j)=(s*drda(j)-r*dsda(j))/s**2
      enddo
      return
      end
